package net.mcreator.razertimessimpleadditions.client.renderer;

import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.texture.OverlayTexture;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.renderer.entity.EntityRenderer;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.MultiBufferSource;

import net.mcreator.razertimessimpleadditions.entity.ExplodingbambooEntity;
import net.mcreator.razertimessimpleadditions.client.model.ModelBamBOOMProjectile_Converted;

import com.mojang.math.Axis;
import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

public class ExplodingbambooRenderer extends EntityRenderer<ExplodingbambooEntity> {
	private static final ResourceLocation texture = new ResourceLocation("razertimes_simple_additions:textures/entities/bamboomprojectiletexture.png");
	private final ModelBamBOOMProjectile_Converted model;

	public ExplodingbambooRenderer(EntityRendererProvider.Context context) {
		super(context);
		model = new ModelBamBOOMProjectile_Converted(context.bakeLayer(ModelBamBOOMProjectile_Converted.LAYER_LOCATION));
	}

	@Override
	public void render(ExplodingbambooEntity entityIn, float entityYaw, float partialTicks, PoseStack poseStack, MultiBufferSource bufferIn, int packedLightIn) {
		VertexConsumer vb = bufferIn.getBuffer(RenderType.entityCutout(this.getTextureLocation(entityIn)));
		poseStack.pushPose();
		poseStack.mulPose(Axis.YP.rotationDegrees(Mth.lerp(partialTicks, entityIn.yRotO, entityIn.getYRot()) - 90));
		poseStack.mulPose(Axis.ZP.rotationDegrees(90 + Mth.lerp(partialTicks, entityIn.xRotO, entityIn.getXRot())));
		model.renderToBuffer(poseStack, vb, packedLightIn, OverlayTexture.NO_OVERLAY, 1, 1, 1, 0.0625f);
		poseStack.popPose();
		super.render(entityIn, entityYaw, partialTicks, poseStack, bufferIn, packedLightIn);
	}

	@Override
	public ResourceLocation getTextureLocation(ExplodingbambooEntity entity) {
		return texture;
	}
}
